package com.finstone.house.app.service.jiangsu.hcp;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.finstone.house.app.util.DateUtils;
import com.finstone.house.app.util.sm.SM2Utils;
import com.finstone.house.app.util.sm.Utils;
import com.finstone.house.core.support.Constants;
import com.finstone.house.iface.ws.client.ygj.util.HttpsClient;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import sviolet.smcrypto.SmCryptoUtil;

@RequestMapping({"/service/js"})
@Controller
public class HcpController {

   protected Log logger = LogFactory.getLog(this.getClass());
   private static Map pathCode = new HashMap();
   private static Map codeName = new HashMap();


   static {
      pathCode.put("hcp01", "hcp01");
      codeName.put("hcp01", "好差评数据上报");
   }

   @RequestMapping(
      value = {"hcp01"},
      method = {RequestMethod.POST}
   )
   public void invoke_hcp01(HttpServletRequest request, HttpServletResponse response) throws Exception {
      this.invoke(request, response);
   }

   public void invoke(HttpServletRequest request, HttpServletResponse response) throws Exception {
      request.setCharacterEncoding("UTF-8");
      int size = request.getContentLength();
      ServletInputStream is = request.getInputStream();
      byte[] reqBodyBytes = readBytes(is, size);
      String reqData = new String(reqBodyBytes, "UTF-8");
      String path = request.getServletPath();
      path = path.substring(path.lastIndexOf("/") + 1);
      String sTranscode = (String)pathCode.get(path);
      String transName = (String)codeName.get(sTranscode);
      new HashMap();
      HashMap requestData = new HashMap();
      new HashMap();
      new HashMap();
      HashMap responseMap = new HashMap();
      HashMap temMap = new HashMap();
      String rspData = "";
      String result = "";
      String sTime = DateUtils.format(new Date(), "yyyyMMddHHmmss");
      this.logger.info("esb业务接收>>>>>>>" + reqData);

      try {
         Map requestMap = (Map)JSONObject.parseObject(reqData, Map.class);
         String list = (String)requestMap.get("httpurl");
         String plainText = sTime + Constants.jshcp_accessId + Constants.jshcp_accessToken;
         String sSign = SmCryptoUtil.sm2Encode(plainText, Constants.jshcp_pubk);
         requestData.put("appMark", Constants.jshcp_accessId);
         requestData.put("time", sTime);
         requestData.put("sign", sSign);
         JSONObject jBody = (JSONObject)requestMap.get("params");
         requestData.put("params", SmCryptoUtil.sm2Encode(jBody.toJSONString(), Constants.jshcp_pubk));
         this.logger.info("[" + path + "][" + transName + "]向" + list + "发起数据请求>>>>>>>" + requestData);
         result = HttpsClient.postHttps(list, requestData, (String)null);
         this.logger.info("esb业务返回>>>>>>>" + result);
         JSONObject jsonRsp = JSONObject.parseObject(result);
         String sCode = (String)jsonRsp.get("code");
         if(sCode.equals("1")) {
            responseMap.put("error_code", "99");
            responseMap.put("error_msg", (String)jsonRsp.get("message"));
         } else {
            responseMap.put("error_code", (String)jsonRsp.get("code"));
            responseMap.put("error_msg", (String)jsonRsp.get("message"));
         }
      } catch (Exception var25) {
         responseMap.put("error_code", "99");
         responseMap.put("error_msg", var25.getLocalizedMessage());
         this.logger.info("服务端程序出现错误>>>>>>>" + var25.getMessage());
      }

      ArrayList list1 = new ArrayList();
      temMap.put("data", list1);
      responseMap.put("result", temMap);
      responseMap.put("ysbw", result);
      rspData = JSON.toJSONString(responseMap);
      this.logger.info("esb最终返回>>>>>>>" + rspData);
      response.getWriter().write(rspData);
   }

   public String getRemoteHost(HttpServletRequest request) {
      String ip = request.getHeader("x-forwarded-for");
      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getHeader("Proxy-Client-IP");
      }

      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getHeader("WL-Proxy-Client-IP");
      }

      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getRemoteAddr();
      }

      return ip.equals("0:0:0:0:0:0:0:1")?"127.0.0.1":ip;
   }

   public static final byte[] readBytes(InputStream is, int contentLen) {
      if(contentLen > 0) {
         int readLen = 0;
         boolean readLengthThisTime = false;
         byte[] message = new byte[contentLen];

         try {
            while(readLen != contentLen) {
               int readLengthThisTime1 = is.read(message, readLen, contentLen - readLen);
               if(readLengthThisTime1 == -1) {
                  break;
               }

               readLen += readLengthThisTime1;
            }

            return message;
         } catch (IOException var6) {
            var6.printStackTrace();
         }
      }

      return new byte[0];
   }

   public static void main(String[] args) throws Exception {
      String sTime = DateUtils.format(new Date(), "yyyyMMddHHmmss");
      String plainText = sTime + Constants.jshcp_accessId + Constants.jshcp_accessToken;
      byte[] sourceData = plainText.getBytes("UTF-8");
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
      Date sd = new Date();
      String kssj = sdf.format(sd);
      System.out.println("加密1: " + kssj);
      String sm2Encode = SmCryptoUtil.sm2Encode(plainText, Constants.jshcp_pubk);
      System.out.println(sm2Encode);
      Date ed = new Date();
      String jssj = sdf.format(ed);
      System.out.println("加密2: " + jssj);
      String sSign = SM2Utils.encrypt(Utils.hexToByte(Constants.jshcp_pubk), sourceData);
      System.out.println(sSign);
      sd = new Date();
      kssj = sdf.format(sd);
      System.out.println("解密1: " + kssj);
      String privateKeysm2 = Constants.jshcp_prik;
      String sm2Decode = SmCryptoUtil.sm2Decode(sm2Encode, privateKeysm2);
      System.out.println(sm2Decode);
      ed = new Date();
      jssj = sdf.format(ed);
      System.out.println("解密2: " + jssj);
      plainText = new String(SM2Utils.decrypt(Utils.hexToByte(privateKeysm2), Utils.hexToByte(sSign)), "UTF-8");
      ed = new Date();
      jssj = sdf.format(ed);
      System.out.println(jssj + ": " + plainText);
      String reqData = "{\"params\":{\"proTaskCode\":\"0211A0JG0028010211A00028\",\"proTaskHandleItem\":\"0211A0JG0028010211A00028001\",\"proDepart\":\"国盾公司\"},\"httpurl\":\"http://58.215.18.194:7002/ipgs/wbjk/saveHcpPjSb.do\"}";
      Map requestMap = (Map)JSONObject.parseObject(reqData, Map.class);
      JSONObject jBody = (JSONObject)requestMap.get("params");
      System.out.println(jBody.toJSONString());
      sm2Encode = SmCryptoUtil.sm2Encode(jBody.toJSONString(), Constants.jshcp_pubk);
      System.out.println(sm2Encode);
      sm2Decode = SmCryptoUtil.sm2Decode(sm2Encode, privateKeysm2);
      System.out.println(sm2Decode);
   }
}
